
// 按钮代理操作
function proxy(event) {
    let parentName = this.$parent.$options.name

    // 没有代理内容
    if (parentName != 'ElTableRow' || !this.proxyList || !this.proxyList.length) {
        return this.$emit('click', event)
    }
    // 获取当前按钮名称
    let text = this.$slots.default && this.$slots.default[0]?.text
    text = text.trim()

    // 当前按钮是否是代理按钮
    let isExists = this.proxyList.find(item => {
        if (typeof item == 'object') {
            return item.name === text
        }
        if (typeof item == 'string') {
            return item === text
        }
    })
    if (!isExists) {
        return this.$emit('click', event)
    }

    // 将自定义代理列表数据进行转换
    if (typeof isExists == 'string') {
        isExists = {
            name: isExists
        }
    }
    // 合并配置项
    let options = Object.assign({}, defaultOptions, { parentName }, isExists, this.options)
    let action = options.action || proxy.action
    // 启用默认代理
    action.call(this, options, event).then(() => {
        return this.$emit('click', event)
    })

}
proxy.action = function(options, event) {
    let { message, title, type, confirmButtonText, cancelButtonText, parentName } = options
    return new Promise(resolve => {
        if (!this.$confirm) {
            return resolve()
        }
        this.$confirm(message, title, {
            confirmButtonText: confirmButtonText,
            cancelButtonText: cancelButtonText,
            type: type
        }).then(() => {
            return resolve()
        }).catch(() => {});
    })
}


var defaultOptions = {
    confirmButtonText: '确定',
    cancelButtonText: '取消',
    type: 'warning',
    title: '提示'
}



export default proxy